#include <iostream>

#include "Advanced_genericity.h"

Female::operator Male() const {
	return Male(identity);
}

Male::operator Female() const {
	return Female(identity);
}
// (Incidental?) overload:
void my_function(char& c) {
	std::cout << "'char& c' ver.: " << c << std::endl;
};

int main(int argc, char** argv) {
	Male Adam("XY");
	Female Eve("XX");
	// Transgender:
	static_cast<Male> (Eve); // Use debugger to enter into 'Female::operator Male() const'
	// Transgender:
	static_cast<Female> (Adam); // Use debugger to enter into 'Male::operator Female() const'
	// Use specialization:
	static_cast<Minotaur> (Adam); // Use debugger to enter into 'template<> Male::operator Minotaur() const'
	// Explicit instantiation 'template Female::operator Medusa() const':
	static_cast<Medusa> (Eve); // Use debugger to enter into 'template<typename Specie> explicit operator Specie() const'

	// ::my_function(); // Compilation error: 'candidate template ignored: couldn't infer template argument 'T''
	char BEL = '\a';
	::my_function(BEL); // Existing overload preemption...
	::my_function<char>(BEL); // Explicit instantiation ('T' = 'char')
	std::string a = "a";
	// Or '::my_function<std::string>(a);':
	::my_function(a); // Implicit instantiation ('T' = 'std::string')

	std::cout << Mid<float> << std::endl;

	return 0;
}

